    Program f01vlfe

!     F01VLF Example Program Text

!     Mark 24 Release. NAG Copyright 2012.

!     .. Use Statements ..
      Use nag_library, Only: dtfttp, nag_wp, x04cbf
!     .. Implicit None Statement ..
      Implicit None
!     .. Parameters ..
      Integer, Parameter               :: inc1 = 1, indent = 0, ncols = 80,    &
                                          nin = 5, nout = 6
      Character (1), Parameter         :: diag = 'N', intlabel = 'I', matrix = &
                                          'G', nolabel = 'N'
      Character (4), Parameter         :: form = 'F5.2'
!     .. Local Scalars ..
      Integer                          :: ifail, info, lenap, lenarf, n
      Character (21)                   :: title
      Character (1)                    :: transr, uplo
!     .. Local Arrays ..
      Real (Kind=nag_wp), Allocatable  :: ap(:), arf(:)
      Character (1)                    :: clabs(1), rlabs(1)
!     .. Executable Statements ..
      Write (nout,*) 'F01VLF Example Program Results'
!     Skip heading in data file
      Read (nin,*)
      Write (nout,*)
      Flush (nout)
      Read (nin,*) n, uplo, transr
      lenap = (n*(n+1))/2
      lenarf = lenap

      Allocate (ap(lenap),arf(lenarf))

!     Read an RFP matrix into array ARF
      Read (nin,*) arf(1:lenarf)

!     Print the Rectangular Full Packed array
      title = 'RFP Packed Array ARF:'
      ifail = 0
      Call x04cbf(matrix,diag,lenarf,inc1,arf,lenarf,form,title,intlabel, &
        rlabs,nolabel,clabs,ncols,indent,ifail)

      Write (nout,*)
      Flush (nout)

!     Convert to packed vector form
      info = 0
!     The NAG name equivalent of dtfttp is f01vlf
      Call dtfttp(transr,uplo,n,arf,ap,info)

!     Print the packed vector
      title = 'Packed Array AP:     '
      ifail = 0
      Call x04cbf(matrix,diag,lenap,inc1,ap,lenap,form,title,intlabel,rlabs, &
        nolabel,clabs,ncols,indent,ifail)

    End Program f01vlfe
